﻿using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;

namespace SimpleAuthService
{
    [ServiceContract]
    public interface IRESTService
    {

        // returns a list of claims present in the token
        // return data format: JSON
        [OperationContract, WebGet( UriTemplate = "/getclaims", ResponseFormat = WebMessageFormat.Json )]
        ClaimsOutput GetClaims();

        // returns a message of the day that is contained in the token
        // return data format: JSON
        [OperationContract, WebGet( UriTemplate = "/messageoftheday", ResponseFormat = WebMessageFormat.Json )]
        MofTD GetMofTD();
    }

    public class StringClaim
    {
        public String ClaimType { get; set; }
        public String Value { get; set; }
    }

    public class Identity
    {
        public List<StringClaim> ClaimsList { get; set; }
    }

    // data contract for claim list
    [DataContract]
    public class ClaimsOutput
    {

        [DataMember]
        public List<Identity> UserClaims { get; set; }

        [DataMember]
        public List<Identity> DeviceClaim { get; set; }

        [DataMember]
        public List<Identity> TitleClaim { get; set; }

        [DataMember]
        public List<Identity> AggregateClaims { get; set; } 

    }

    // data contract for the message of the day
    [DataContract]
    public class MofTD
    {
        // Echo string
        [DataMember]
        public String MessageOfTheDay { get; set; }
    }

}
